package holmos.webtest.junitextentions.parameters.csv;

import holmos.webtest.exceptions.HolmosFailedError;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;

import au.com.bytecode.opencsv.CSVReader;

/**
 * 操作csv文件的工具类
 * 
 * @author 吴银龙(sunshine307087558@gmail.com)
 * */
public class HolmosCSVUtils {
	/**
	 * 根据指定的csv文件路径来获取csv文件的读取器
	 * @param csvFilePath csv文件绝对路径
	 * */
	public static CSVReader getCsvReader(String csvFilePath){
		if(!new File(csvFilePath).exists()){
			throw new HolmosFailedError(csvFilePath+"文件不存在!请检查此处文件!");
		}try {
			return new CSVReader(new InputStreamReader(new FileInputStream(new File(csvFilePath)),"GBK"));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		}return null;
	}
	public static ArrayList<String[]>getAllValues(CSVReader csvReader){
		try {
			return (ArrayList<String[]>) csvReader.readAll();
		} catch (IOException e) {
			e.printStackTrace();
		}return null;
	}
}
