package holmos.webtest.junitextentions.parameters.getter;

import holmos.webtest.junitextentions.parameters.csv.HolmosCSVUtils;

import java.util.ArrayList;

import au.com.bytecode.opencsv.CSVReader;
/**
 * @author 吴银龙(sunshine307087558@gmail.com)
 * */
public class CSVDataGetter implements DataGetter{
	private String CSVFilePath;
	private CSVReader csvReader;
	public CSVDataGetter(String CVSFilePath){
		this.CSVFilePath=CVSFilePath;
		this.csvReader=HolmosCSVUtils.getCsvReader(CSVFilePath);
	}
	@Override
	public ArrayList<Object[]> getParameterByIDs(int[] ids) {
		ArrayList<Object[]>result=new ArrayList<Object[]>();
		for(int id:ids)
			result.addAll(getParameterByID(id));
		return result;
	}

	@Override
	public ArrayList<Object[]> getAllParameter() {
		ArrayList<Object[]>result=new ArrayList<Object[]>();
		result.addAll(HolmosCSVUtils.getAllValues(csvReader));
		return result;
	}
	@Override
	public ArrayList<Object[]> getParameterByID(int id) {
		ArrayList<Object[]>result=new ArrayList<Object[]>();
		for(Object[] parameter:getAllParameter()){
			if(Integer.parseInt((String) parameter[0])==id){
				result.add(getActualParameter(parameter));
			}
		}
		return result;
	}
	private Object[]getActualParameter(Object[]parameter){
		Object[] acutalParameter=new Object[parameter.length-1];
		for(int i=1;i<parameter.length;i++)
			acutalParameter[i-1]=parameter[i];
		return acutalParameter;
	}
}
