package holmos.webtest.junitextentions.parameters.getter;

import holmos.webtest.junitextentions.parameters.database.ConnectionInfo;

import java.io.UnsupportedEncodingException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
/**
 * @author 吴银龙(sunshine307087558@gmail.com)
 * */
public class DatabaseDataGetter implements DataGetter{
	/**数据库连接对象*/
	private ConnectionInfo connection=null;
	/**sql查询语句*/
	private String selectSql;
	public DatabaseDataGetter(String selectSql){
		this.selectSql=selectSql;
	}
	
	@Override
	public ArrayList<Object[]> getParameterByIDs(int[] ids) {
		ArrayList<Object[]>result=new ArrayList<Object[]>();
		for(int id:ids)
			result.addAll(getParameterByID(id));
		return result;
	}

	@Override
	public ArrayList<Object[]> getAllParameter() {
		ArrayList<Object[]>result=new ArrayList<Object[]>();
		ResultSet reSet=getSelectResult();
		try {
			for(reSet.next();;reSet.next()){
				result.add(getParameter(reSet));
				if(reSet.isLast())break;
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return result;
	}
	/**id为第一列*/
	private Object[] getParameter(ResultSet resultSet){
		ArrayList<Object>parameter=new ArrayList<Object>();
		try {
			parameter.add(resultSet.getInt(1));
			for(int i=2;i<=resultSet.getMetaData().getColumnCount();i++){
				Object rst=resultSet.getObject(i);
				if(rst instanceof String)
					parameter.add(new String(((String) rst).getBytes(),"GBK"));
				else
					parameter.add(rst);
			}
		} catch (SQLException e) {
			e.printStackTrace();
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		}
		return parameter.toArray();
	}
	public void setConnection(ConnectionInfo connection) {
		this.connection = connection;
	}

	@Override
	public ArrayList<Object[]> getParameterByID(int id) {
		ArrayList<Object[]>result=new ArrayList<Object[]>();
		for(Object[] parameter:getAllParameter()){
			if((Integer)parameter[0]==id){
				result.add(getActualParameter(parameter));
			}
		}
		return result;
	}
	/**
	 * 根据指定的sql，select语句来获得数据
	 * */
	private ResultSet getSelectResult(){
		try {
			Statement select=connection.getConnection().createStatement();
			return select.executeQuery(selectSql);
		} catch (SQLException e) {
			e.printStackTrace();
		}return null;
	}
	private Object[]getActualParameter(Object[]parameter){
		Object[] acutalParameter=new Object[parameter.length-1];
		for(int i=1;i<parameter.length;i++)
			acutalParameter[i-1]=parameter[i];
		return acutalParameter;
	}
}

